package com.nexo.job.service;

import com.alibaba.fastjson2.JSONObject;
import com.nexo.module.api.douyin.RemoteDouYinUserInfoService;
import com.nexo.module.api.douyin.domain.NexoDouyinUserInfo;
import com.nexo.module.api.douyin.utils.DouYinUtils;
import com.xxl.job.core.context.XxlJobContext;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.DubboReference;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * XxlJob开发示例（Bean模式）
 * <p>
 * 开发步骤：
 * 1、任务开发：在Spring Bean实例中，开发Job方法；
 * 2、注解配置：为Job方法添加注解 "@XxlJob(value="自定义jobhandler名称", init = "JobHandler初始化方法", destroy = "JobHandler销毁方法")"，注解value值对应的是调度中心新建任务的JobHandler属性的值。
 * 3、执行日志：需要通过 "XxlJobHelper.log" 打印执行日志；
 * 4、任务结果：默认任务结果为 "成功" 状态，不需要主动设置；如有诉求，比如设置任务结果为失败，可以通过 "XxlJobHelper.handleFail/handleSuccess" 自主设置任务结果；
 *
 * @author xuxueli 2019-12-11 21:52:51
 */
@Slf4j
@Service
public class SampleService {

    @DubboReference
    private RemoteDouYinUserInfoService remoteDouYinUserInfoService;

    /**
     * 抖音直播监控
     */
    @XxlJob("douyinLiveMonitor")
    public void douyinLiveMonitor() throws Exception {
        List<NexoDouyinUserInfo> updateInfoList = remoteDouYinUserInfoService.getUpdateInfoList(null);
        for (int i = 0; i < updateInfoList.size(); i++) {
            NexoDouyinUserInfo info = updateInfoList.get(i);
            List<String> strings = remoteDouYinUserInfoService.getUpdateInfoList(info.getSecUid()).stream().map(item -> item.getSecUid()).collect(Collectors.toList());

        }
        // 通过上下文获取任务参数
        String param = XxlJobContext.getXxlJobContext().getJobParam();
        JSONObject parsed = JSONObject.parseObject(param);
        String sec_uid = parsed.getString("sec_uid");
        NexoDouyinUserInfo userInfo = DouYinUtils.getUserInfo(sec_uid);
        remoteDouYinUserInfoService.updateDouYinUserInfo(userInfo);
    }

}
